<?php
class ControllerPaymentPaykeeper extends Controller {

    private $fiscal_cart = array(); //fz54 cart
    private $order_total = 0; //order total sum
    private $shipping_price = 0; //shipping price
    private $use_taxes = false;
    private $use_delivery = false;
    private $order_params = NULL;
    private $discounts = array();

	public function index() {
		$data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $payment_parameters = http_build_query(array(
            "orderid"=>$this->session->data['order_id'],
            "clientid"=>$order_info['email'],
            "sum"=>$this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false),
            "phone"=>$order_info['telephone']
        ));

        $data['server'] = $this->config->get('paykeeperserver');
        $data['payment_parameters'] = $payment_parameters;

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper.tpl')) {
			return $this->load->view($this->config->get('config_template') . '/template/payment/paykeeper.tpl', $data);
		} else {
			return $this->load->view('payment/paykeeper.tpl', $data);
		}
	}
	public function callback() {

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			$this->load->model('checkout/order');
			
			if(isset($this->request->post['id']) && isset($this->request->post['orderid'])){
				$secret_seed = $this->config->get('paykeepersecret');
				$id = $this->request->post['id'];
				$sum = $this->request->post['sum'];
				$clientid = $this->request->post['clientid'];
				$orderid = $this->request->post['orderid'];
				$key = $this->request->post['key'];

				if ($key != md5 ($id . sprintf ("%.2lf", $sum).$clientid.$orderid.$secret_seed))
				{
					echo "Error! Hash mismatch";
					exit;
				}
				
				$order_info = $this->model_checkout_order->getOrder($orderid);
				
				if ($orderid == "")
				{
                    echo "Empty order!";
				}
				else
				{
					$this->model_checkout_order->addOrderHistory($orderid, $this->config->get('paykeeper_order_status_id'));
				}
				echo "OK ".md5($id.$secret_seed);
			}
			else echo "OK";
		}
	}
	
	public function gopay() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('payment/paykeeper');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('paykeeper_title'),
			'href' => $this->url->link('payment/paykeeper/gopay', '', 'SSL')
		);
		$data['heading_title'] = $this->language->get('paykeeper_title');
		$this->document->setTitle($data['heading_title']);
		
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $decimal_place = $this->currency->getDecimalPlace($order_info['currency_code']);

		//$payment_parameters = http_build_query(array(
			//"orderid"=>$this->session->data['order_id'],
			//"clientid"=>$order_info['email'],
			//"sum"=>$this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false),
			//"phone"=>$order_info['telephone']
		//));
		
		//$options = array("http"=>array(
			//"method"=>"POST",
			//"header"=>"Content-type: application/x-www-form-urlencoded",
			//"content"=>$payment_parameters
		//));
		//$data['options'] = $options;

		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
        $data['obj'] = $this;
        $data['sum'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
        $data['orderid'] = $this->session->data['order_id'];
        $data['clientid'] = $this->session->data['payment_address']['firstname'] . " " . $this->session->data['payment_address']['lastname'];
        $data['client_email'] = $order_info['email'];
        $data['client_phone'] = $order_info['telephone'];
        $data['service_name'] = "";
		$data['server'] = $this->config->get('paykeeperserver');
		$data['secret'] = $this->config->get('paykeepersecret');

        //set order parameters
        $this->setOrderParams(
            $data['sum'],          //sum
            $data['clientid'],     //clientid
            $data['orderid'],      //orderid
            $data['client_email'], //client_email
            $data['client_phone'], //client_phone
            "",                    //service_name
            $data['server'],       //payment form url
            $data['secret']        //secret key
        );

        //GENERATE FZ54 CART
        $cart_check_sum = 0;

        $cart_data = $this->cart->getProducts();

        foreach ($cart_data as $cart_item) {
            $taxes = array("tax" => "none", "tax_sum" => 0);
            $name = $cart_item["name"];
            $qty = $cart_item["quantity"];
            $price = ((int) $decimal_place == 1) ? $this->correctPrice($cart_item["price"], $qty) :
                round($cart_item["price"], (int) $decimal_place+1);
            $sum = number_format($price*$qty, 2, ".", "");
            $cart_check_sum += $sum;

            if ( (int)$cart_item["tax_class_id"] != 0) {
                $tax_data = array_values($this->tax->getRates($sum, $cart_item['tax_class_id']))[0];
                $tax_rate = (int) $tax_data["rate"];
                $taxes = $this->setTaxes($sum, $tax_rate);
            }

            $this->updateFiscalCart($this->getPaymentFormType(), 
                                    $name, $price, $qty, $sum, $taxes["tax"], $taxes["tax_sum"]);
        }

        //add shipping service
        if (array_key_exists('shipping_method', $this->session->data)) {
            $shipping_tax_rate = 0;
            $shipping_taxes = array("tax" => "none", "tax_sum" => 0);
            $this->setShippingPrice($this->session->data['shipping_method']['cost']);
            $shipping_name = $this->session->data['shipping_method']['title'];
            $shipping_tax_class_id = $this->session->data["shipping_method"]["tax_class_id"];
            if ($shipping_tax_class_id > 0) {
                $shipping_tax_data = array_values($this->cart->tax->getRates($this->getShippingPrice(), $shipping_tax_class_id))[0];
                $shipping_tax_rate = (int) $shipping_tax_data["rate"];
                $shipping_taxes = $this->setTaxes($this->getShippingPrice(), $shipping_tax_rate);
            }
            $this->updateFiscalCart($this->getPaymentFormType(),
                                    $shipping_name,
                                    $this->getShippingPrice(), 1, 
                                    $this->getShippingPrice(), 
                                    $shipping_taxes["tax"],
                                    $shipping_taxes["tax_sum"]);

        }

        //set discounts
        $cart_check_sum = $this->setDiscounts($cart_check_sum);

        //handle possible precision problem
        $this->correctPrecision($cart_check_sum);

        $fiscal_cart_to_encode = str_replace("'", '&#39;', $this->getFiscalCart());
        $data['cart'] = json_encode($fiscal_cart_to_encode);

        //generate payment form
        $form = "";
        if ($this->getPaymentFormType() == "create") { //create form
            $to_hash = $this->getOrderTotal(TRUE)                .
                       $this->getOrderParams("clientid")     .
                       $this->getOrderParams("orderid")      .
                       $this->getOrderParams("service_name") .
                       $this->getOrderParams("client_email") .
                       $this->getOrderParams("client_phone") .
                       $this->getOrderParams("secret_key");
            $data['sign'] = hash ('sha256' , $to_hash);
        }
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper_iframe.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/paykeeper_iframe.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('payment/paykeeper_iframe.tpl', $data));
		}
	}
	public function success() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('payment/paykeeper');

        //clear cart
        $this->cart->clear();
		
		$data['heading_title'] = $this->language->get('paykeeper_title');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['message'] = $this->language->get('paykeeper_success');

		$this->document->setTitle($data['message']);
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('payment/paykeeper_feedback.tpl', $data));
		}
	}
	public function failed() {
		
		$this->load->language('checkout/checkout');
		$this->load->language('payment/paykeeper');
		
		$data['heading_title'] = $this->language->get('paykeeper_title');
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_cart'),
			'href' => $this->url->link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('checkout/checkout', '', 'SSL')
		);
		
		$data['message'] = $this->language->get('paykeeper_failed');

		$this->document->setTitle($data['message']);
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/payment/paykeeper_feedback.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('payment/paykeeper_feedback.tpl', $data));
		}
	}

    public function confirm() {
        $this->load->model('checkout/order');
        $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 1);
    }

    protected function setOrderParams($order_total = 0, $clientid="", $orderid="", $client_email="", 
        $client_phone="", $service_name="", $form_url="", $secret_key="")
    {
       $this->setOrderTotal($order_total);
       $this->order_params = array(
           "sum" => $order_total,
           "clientid" => $clientid,
           "orderid" => $orderid,
           "client_email" => $client_email,
           "client_phone" => $client_phone,
           "phone" => $client_phone,
           "service_name" => $service_name,
           "form_url" => $form_url,
           "secret_key" => $secret_key,
       );
    }

    protected function getOrderParams($value)
    {
        return array_key_exists($value, $this->order_params) ? $this->order_params["$value"] : False;
    }

    protected function updateFiscalCart($ftype, $name="", $price=0, $quantity=0, $sum=0, $tax="none", $tax_sum=0)
    {
        //update fz54 cart
        if ($ftype === "create") {
            $name = str_replace("\n ", "", $name);
            $name = str_replace("\r ", "", $name);
        }
        $this->fiscal_cart[] = array(
            "name" => $name,
            "price" => $price,
            "quantity" => $quantity,
            "sum" => $sum,
            "tax" => $tax,
            "tax_sum" => number_format($tax_sum, 2, ".", "")
        );
    }

    protected function getFiscalCart()
    {
        return $this->fiscal_cart;
    }

    protected function setDiscounts($cart_sum)
    {
        $cart_sum_with_discount = $cart_sum;

        //check if discount is active
        if (array_key_exists("coupon", $this->session->data)) {
            $discount_modifier_value = ($this->getOrderTotal(FALSE) - $this->getShippingPrice())/$cart_sum;

            if ($discount_modifier_value < 1) {
                $cart_sum_with_discount = 0;
                $fiscal_cart_count = ($this->getShippingPrice() != 0) ? count($this->getFiscalCart())-1
                    : count($this->getFiscalCart());
                //iterate fiscal cart without shipping
                for ($pos=0; $pos<$fiscal_cart_count; $pos++) {
                    $this->fiscal_cart[$pos]["sum"] *= $discount_modifier_value;
                    $cart_sum_with_discount += $this->fiscal_cart[$pos]["sum"];
                    $this->fiscal_cart[$pos]["price"] = $this->fiscal_cart[$pos]["sum"]/$this->fiscal_cart[$pos]["quantity"];
                    //formatting
                    $this->fiscal_cart[$pos]["price"] = number_format($this->fiscal_cart[$pos]["price"], 3, ".", "");
                    $this->fiscal_cart[$pos]["sum"] = number_format($this->fiscal_cart[$pos]["sum"], 2, ".", "");
                    //recalculate taxes
                    $this->recalculateTaxes($pos);
                }
            }
        }
        return $cart_sum_with_discount;
    }

    protected function correctPrecision($cart_sum)
    {
        //handle possible precision problem
        $fiscal_cart_sum = $cart_sum;
        $total_sum = $this->getOrderTotal(TRUE);
        //add shipping sum to cart sum
        $fiscal_cart_sum += $this->getShippingPrice();
        //if ($this->getShippingPrice() > 0)
        //    $fiscal_cart_sum += $this->fiscal_cart[count($this->fiscal_cart)-1]['sum'];

        //debug_info
        //echo "total: " . $total_sum . " - cart: " . $cart_sum;
        $diff_sum = $fiscal_cart_sum - $total_sum;
        if (abs($diff_sum) <= 0.01) {
            $this->setOrderTotal(number_format($total_sum+$diff_sum, 2, ".", ""));
        }
        else {
            if ($this->getUseDelivery() && ($fiscal_cart_sum < $total_sum)) {
                $delivery_pos = count($this->getFiscalCart())-1;
                $this->fiscal_cart[$delivery_pos]["price"] = number_format(
                                   $this->fiscal_cart[$delivery_pos]["price"]+abs($diff_sum), 2, ".", "");
                $this->fiscal_cart[$delivery_pos]["sum"] = number_format(
                                   $this->fiscal_cart[$delivery_pos]["sum"]+abs($diff_sum), 2, ".", "");
                $this->recalculateTaxes($delivery_pos);
            }
        }
    }

    protected function setOrderTotal($value)
    {
        $this->order_total = $value;
    }

    protected function getOrderTotal($format)
    {
        return ($format) ? number_format($this->order_total, 2, ".", "")
            : $this->order_total;
    }

    protected function setShippingPrice($value)
    {
        $this->shipping_price = $value;
    }

    protected function getShippingPrice()
    {
        return $this->shipping_price;
    }

    protected function getPaymentFormType()
    {
        if (strpos($this->order_params["form_url"], "/order/inline") == TRUE)
            return "order";
        else
            return "create";
    }

    protected function setUseTaxes()
    {
        $this->use_taxes = TRUE;
    }

    protected function getUseTaxes()
    {
        return $this->use_taxes;
    }

    protected function setUseDelivery()
    {
        $this->use_delivery = TRUE;
    }

    protected function getUseDelivery()
    {
        return $this->use_delivery;
    }

    protected function recalculateTaxes($item_pos)
    {
        //recalculate taxes
        switch($this->fiscal_cart[$item_pos]['tax']) {
            case "vat10":
                $this->fiscal_cart[$item_pos]['tax_sum'] = round((float)
                    (($this->fiscal_cart[$item_pos]['sum']/110)*10), 2);
                break;
            case "vat18":
                $this->fiscal_cart[$item_pos]['tax_sum'] = round((float)
                    (($this->fiscal_cart[$item_pos]['sum']/118)*18), 2);
                break;
            case "vat20":
                $this->fiscal_cart[$item_pos]['tax_sum'] = round((float)
                    (($this->fiscal_cart[$item_pos]['sum']/120)*20), 2);
                break;
        }
    }

    protected function setTaxes($sum, $tax_rate)
    {
        $taxes = array("tax" => "none", "tax_sum" => 0);
        switch(number_format($tax_rate, 0, ".", "")) {
            case 10:
                $taxes["tax"] = "vat10";
                $taxes["tax_sum"] = round((float)(($sum/110)*10), 2);
                break;
            case 18:
                $taxes["tax"] = "vat18";
                $taxes["tax_sum"] = round((float)(($sum/118)*18), 2);
                break;
            case 20:
                $taxes["tax"] = "vat20";
                $taxes["tax_sum"] = round((float)(($sum/120)*20), 2);
                break;
        }
        return $taxes;
    }

    protected function getTaxRate($tax, $price, $is_shipping)
    {
        $tax = (float) $tax;
        $price = (float) $price;

        if ($is_shipping)
            return round(($tax/($price/100)), 0);
        else
            return ($this->order->is_including_tax) ? round(($tax*100/($price-$tax)), 0)
                : round(($tax/(($price - $tax)/100)), 0);
    }

    protected function correctPrice($price, $quantity)
    {
        $sum = number_format((float) $price * $quantity, 1, ".", "");
        return number_format($sum/$quantity, 3, ".", "");
    }

    protected function showDebugInfo($obj_to_debug)
    {
        echo "<pre>";
        var_dump($obj_to_debug);
        echo "</pre>";
    }
}
